# Copyright (c) 2016-2023 Qualcomm Technologies, Inc.
# All Rights Reserved.
# Confidential and Proprietary - Qualcomm Technologies, Inc.
# $QTI_LICENSE_QDN_SH$

# Target board Qualcomm Quartz QCA4024

#
# FTDI interface driver for MPSSE mode of FT2322H
#

interface ftdi

# The vendor ID and Product ID of the adapter
ftdi_vid_pid 0x0403 0x6010

# The USB Device description
# ftdi_device_desc "FT2232C Dual USB-UART/FIFO IC"

# Select the Channel of the FTDI device to use for MPSSE operations
ftdi_channel 0

# The initial values of the FTDI GPIO data and direction registers
ftdi_layout_init 0x0008 0x00fb



transport select jtag

adapter_khz 5000

set CHIPNAME QM4
set TAPTYPE cpu
set IRLEN 4
set CPUTAPID 0x4ba00477
#
# Qualcomm Quartz 402x target device
#

if { [info exists TAPTYPE] } {
    set _TAPTYPE $TAPTYPE
} else {
    set _TAPTYPE cpu
}

if { [info exists CHIPNAME] } {
    set _CHIPNAME $CHIPNAME
} else {
    set _CHIPNAME quartzM4
}

if { [info exists CPUTAPID] } {
    set _CPUTAPID $CPUTAPID
} else {
    set _CPUTAPID 0x4ba00477
}

if { [info exists IRLEN] } {
    set _IRLEN $IRLEN
} else {
    set _IRLEN 4
}

proc after_gdb_detach { } { 
    echo "continue target and shutdown openocd server"
    resume
    shutdown
}

jtag newtap $_CHIPNAME $_TAPTYPE -irlen $_IRLEN -expected-id $_CPUTAPID
set _TARGETNAME $_CHIPNAME.$_TAPTYPE
target create $_TARGETNAME cortex_m -chain-position $_TARGETNAME



$_TARGETNAME configure -endian little
$_TARGETNAME configure -work-area-phys 0x20000000 -work-area-size 0x1000 -work-area-backup 0
$_TARGETNAME configure -event gdb-detach after_gdb_detach

# Select the Quartz M4 CPU as the current target
targets QM4.cpu

init


targets

